/*
 * File:	mwerks.h
 * Purpose:	Define constants used by CodeWarrior toolchain
 *
 * Notes:	
 *
 */

#ifndef _MWERKS_H_
#define _MWERKS_H_

/********************************************************************/

/* 
 * The source uses __interrupt__ to identify a function as
 * an interrupt or exception handler.  Codewarrior uses 
 * __declspec(interrupt), so we are appeasing it like this.
 */
#define __interrupt__	__declspec(interrupt)

/* 
 * Force functions to return values in D0 
 */
#pragma pointers_in_D0

/* 
 * Provide a few assembly instructions for C level routines
 */
#define halt()	asm( halt)
#define nop()	asm( nop)

/********************************************************************/

#endif /* _MWERKS_H_ */
