/*****************************************************************************/
/* Title: Hello_Fl demonstration program                                     */
/*                                                                           */
/* This program will drive the LED D29 located on the phyCORE baseboard once */
/* per second and sends a character string over RS-232. 					 */
/* This action is controlled by the interrupt of Slice Timer 0.  			 */
/*****************************************************************************/

#include "common.h"
#define WAITCOUNT 1000000
void Wait(unsigned int Count);

void main (void)
{
	LED_INIT;
	
	MCF_SLT_SLTCNT0 = 5e7;				// 5e7 * 10ns = 0.5s
	MCF_SLT_SCNT0 = 5e7;
	MCF_SLT_SSR0 |= MCF_SLT_SSR_ST;		// clear timeout
	MCF_SLT_SCR0 |= MCF_SLT_SCR_RUN;	// timer runs continously
	MCF_SLT_SCR0 |= MCF_SLT_SCR_IEN;	// interrupt enable
	
	// assigning the global interrupt level 6 and the priority 7 (highest)
	// within this level.
	
	MCF_INTC_ICR54 = MCF_INTC_ICRn_IL(2) | MCF_INTC_ICRn_IP(7);
	
	// de-mask interrupt 54 slice timer 0
	
	MCF_INTC_IMRH &= ~MCF_INTC_IMRH_INT_MASK54;
	
	// global interrupt enable
	
	asm_set_ipl(0);		// all levels from 0 to 7 are enabled
	
	MCF_SLT_SCR0 |= MCF_SLT_SCR_TEN;	// start timer	
	
	while(1) {
	
	printf("phyCORE-MCF548x Hello_Fl Demo\n\r");
	Wait(WAITCOUNT);
	
	}
	
}

void Wait(unsigned int Count)
{
	volatile unsigned n;
	
	for(n = 0; n < Count; n++) {}
}

__interrupt__
void slt0(void)
{
	MCF_SLT_SSR0 |= MCF_SLT_SSR_ST;		// clear flag
	LED_TOGGLE;							// toggle LED
}
