/*
 * File:	vectors.s
 * Purpose:	MCF548x vector table
 */

#ifdef 	_UNDERSCORE_
#define	__SP_INIT					___SP_INIT
#define asm_startmeup				_asm_startmeup
#define asm_exception_handler   	_asm_exception_handler
#endif

#define slt0	_slt0

#ifdef __ghs__
	.globl VECTOR_TABLE
	.globl start
#else
	.global VECTOR_TABLE
	.global _VECTOR_TABLE
	.global start
#endif

	.extern __SP_INIT
	.extern asm_startmeup
	.extern asm_exception_handler
	.extern slt0

	.text
	
/*
 * Exception Vector Table
 */
VECTOR_TABLE:
_VECTOR_TABLE:
INITSP:		.long	__SP_INIT				/* Initial SP			*/
INITPC:		.long	start					/* Initial PC			*/
vector02:	.long	asm_exception_handler	/* Access Error			*/
vector03:	.long	asm_exception_handler	/* Address Error		*/
vector04:	.long	asm_exception_handler	/* Illegal Instruction	*/
vector05:	.long	asm_exception_handler	/* Reserved				*/
vector06:	.long	asm_exception_handler	/* Reserved				*/
vector07:	.long	asm_exception_handler	/* Reserved				*/
vector08:	.long	asm_exception_handler	/* Privilege Violation	*/
vector09:	.long	asm_exception_handler	/* Trace				*/
vector0A:	.long	asm_exception_handler	/* Unimplemented A-Line	*/
vector0B:	.long	asm_exception_handler	/* Unimplemented F-Line	*/
vector0C:	.long	asm_exception_handler	/* Debug Interrupt		*/
vector0D:	.long	asm_exception_handler	/* Reserved				*/
vector0E:	.long	asm_exception_handler	/* Format Error			*/
vector0F:	.long	asm_exception_handler	/* Unitialized Int.		*/
vector10:	.long	asm_exception_handler	/* Reserved				*/
vector11:	.long	asm_exception_handler	/* Reserved				*/
vector12:	.long	asm_exception_handler	/* Reserved				*/
vector13:	.long	asm_exception_handler	/* Reserved				*/
vector14:	.long	asm_exception_handler	/* Reserved				*/
vector15:	.long	asm_exception_handler	/* Reserved				*/
vector16:	.long	asm_exception_handler	/* Reserved				*/
vector17:	.long	asm_exception_handler	/* Reserved				*/
vector18:	.long	asm_exception_handler	/* Spurious Interrupt	*/
vector19:	.long	asm_exception_handler				/* Autovector Level 1	*/
vector1A:	.long	asm_exception_handler				/* Autovector Level 2	*/
vector1B:	.long	asm_exception_handler				/* Autovector Level 3	*/
vector1C:	.long	asm_exception_handler				/* Autovector Level 4	*/
vector1D:	.long	asm_exception_handler				/* Autovector Level 5	*/
vector1E:	.long	asm_exception_handler				/* Autovector Level 6	*/
vector1F:	.long	asm_exception_handler				/* Autovector Level 7	*/
vector20:	.long	asm_exception_handler	/* TRAP #0				*/
vector21:	.long	asm_exception_handler	/* TRAP #1				*/
vector22:	.long	asm_exception_handler	/* TRAP #2				*/
vector23:	.long	asm_exception_handler	/* TRAP #3				*/
vector24:	.long	asm_exception_handler	/* TRAP #4				*/
vector25:	.long	asm_exception_handler	/* TRAP #5				*/
vector26:	.long	asm_exception_handler	/* TRAP #6				*/
vector27:	.long	asm_exception_handler	/* TRAP #7				*/
vector28:	.long	asm_exception_handler	/* TRAP #8				*/
vector29:	.long	asm_exception_handler	/* TRAP #9				*/
vector2A:	.long	asm_exception_handler	/* TRAP #10				*/
vector2B:	.long	asm_exception_handler	/* TRAP #11				*/
vector2C:	.long	asm_exception_handler	/* TRAP #12				*/
vector2D:	.long	asm_exception_handler	/* TRAP #13				*/
vector2E:	.long	asm_exception_handler	/* TRAP #14				*/
vector2F:	.long	asm_exception_handler	/* TRAP #15				*/
vector30:	.long	asm_exception_handler	/* Reserved				*/
vector31:	.long	asm_exception_handler	/* Reserved				*/
vector32:	.long	asm_exception_handler	/* Reserved				*/
vector33:	.long	asm_exception_handler	/* Reserved				*/
vector34:	.long	asm_exception_handler	/* Reserved				*/
vector35:	.long	asm_exception_handler	/* Reserved				*/
vector36:	.long	asm_exception_handler	/* Reserved				*/
vector37:	.long	asm_exception_handler	/* Reserved				*/
vector38:	.long	asm_exception_handler	/* Reserved				*/
vector39:	.long	asm_exception_handler	/* Reserved				*/
vector3A:	.long	asm_exception_handler	/* Reserved				*/
vector3B:	.long	asm_exception_handler	/* Reserved				*/
vector3C:	.long	asm_exception_handler	/* Reserved				*/
vector3D:	.long	asm_exception_handler	/* Reserved				*/
vector3E:	.long	asm_exception_handler	/* Reserved				*/
vector3F:	.long	asm_exception_handler	/* Reserved				*/
vector40:	.long	asm_exception_handler
vector41:	.long	asm_exception_handler
vector42:	.long	asm_exception_handler
vector43:	.long	asm_exception_handler
vector44:	.long	asm_exception_handler
vector45:	.long	asm_exception_handler
vector46:	.long	asm_exception_handler
vector47:	.long	asm_exception_handler
vector48:	.long	asm_exception_handler
vector49:	.long	asm_exception_handler
vector4A:	.long	asm_exception_handler
vector4B:	.long	asm_exception_handler
vector4C:	.long	asm_exception_handler
vector4D:	.long	asm_exception_handler
vector4E:	.long	asm_exception_handler
vector4F:	.long	asm_exception_handler
vector50:	.long	asm_exception_handler
vector51:	.long	asm_exception_handler
vector52:	.long	asm_exception_handler
vector53:	.long	asm_exception_handler
vector54:	.long	asm_exception_handler
vector55:	.long	asm_exception_handler
vector56:	.long	asm_exception_handler
vector57:	.long	asm_exception_handler
vector58:	.long	asm_exception_handler
vector59:	.long	asm_exception_handler
vector5A:	.long	asm_exception_handler
vector5B:	.long	asm_exception_handler
vector5C:	.long	asm_exception_handler
vector5D:	.long	asm_exception_handler
vector5E:	.long	asm_exception_handler
vector5F:	.long	asm_exception_handler
vector60:	.long	asm_exception_handler
vector61:	.long	asm_exception_handler
vector62:	.long	asm_exception_handler
vector63:	.long	asm_exception_handler
vector64:	.long	asm_exception_handler
vector65:	.long	asm_exception_handler
vector66:	.long	asm_exception_handler
vector67:	.long	asm_exception_handler
vector68:	.long	asm_exception_handler
vector69:	.long	asm_exception_handler
vector6A:	.long	asm_exception_handler
vector6B:	.long	asm_exception_handler
vector6C:	.long	asm_exception_handler
vector6D:	.long	asm_exception_handler
vector6E:	.long	asm_exception_handler
vector6F:	.long	asm_exception_handler
vector70:	.long	asm_exception_handler
vector71:	.long	asm_exception_handler
vector72:	.long	asm_exception_handler
vector73:	.long	asm_exception_handler
vector74:	.long	asm_exception_handler
vector75:	.long	asm_exception_handler
vector76:	.long	slt0
vector77:	.long	asm_exception_handler
vector78:	.long	asm_exception_handler
vector79:	.long	asm_exception_handler
vector7A:	.long	asm_exception_handler
vector7B:	.long	asm_exception_handler
vector7C:	.long	asm_exception_handler
vector7D:	.long	asm_exception_handler
vector7E:	.long	asm_exception_handler
vector7F:	.long	asm_exception_handler
vector80:	.long	asm_exception_handler
vector81:	.long	asm_exception_handler
vector82:	.long	asm_exception_handler
vector83:	.long	asm_exception_handler
vector84:	.long	asm_exception_handler
vector85:	.long	asm_exception_handler
vector86:	.long	asm_exception_handler
vector87:	.long	asm_exception_handler
vector88:	.long	asm_exception_handler
vector89:	.long	asm_exception_handler
vector8A:	.long	asm_exception_handler
vector8B:	.long	asm_exception_handler
vector8C:	.long	asm_exception_handler
vector8D:	.long	asm_exception_handler
vector8E:	.long	asm_exception_handler
vector8F:	.long	asm_exception_handler
vector90:	.long	asm_exception_handler
vector91:	.long	asm_exception_handler
vector92:	.long	asm_exception_handler
vector93:	.long	asm_exception_handler
vector94:	.long	asm_exception_handler
vector95:	.long	asm_exception_handler
vector96:	.long	asm_exception_handler
vector97:	.long	asm_exception_handler
vector98:	.long	asm_exception_handler
vector99:	.long	asm_exception_handler
vector9A:	.long	asm_exception_handler
vector9B:	.long	asm_exception_handler
vector9C:	.long	asm_exception_handler
vector9D:	.long	asm_exception_handler
vector9E:	.long	asm_exception_handler
vector9F:	.long	asm_exception_handler
vectorA0:	.long	asm_exception_handler
vectorA1:	.long	asm_exception_handler
vectorA2:	.long	asm_exception_handler
vectorA3:	.long	asm_exception_handler
vectorA4:	.long	asm_exception_handler
vectorA5:	.long	asm_exception_handler
vectorA6:	.long	asm_exception_handler
vectorA7:	.long	asm_exception_handler
vectorA8:	.long	asm_exception_handler
vectorA9:	.long	asm_exception_handler
vectorAA:	.long	asm_exception_handler
vectorAB:	.long	asm_exception_handler
vectorAC:	.long	asm_exception_handler
vectorAD:	.long	asm_exception_handler
vectorAE:	.long	asm_exception_handler
vectorAF:	.long	asm_exception_handler
vectorB0:	.long	asm_exception_handler
vectorB1:	.long	asm_exception_handler
vectorB2:	.long	asm_exception_handler
vectorB3:	.long	asm_exception_handler
vectorB4:	.long	asm_exception_handler
vectorB5:	.long	asm_exception_handler
vectorB6:	.long	asm_exception_handler
vectorB7:	.long	asm_exception_handler
vectorB8:	.long	asm_exception_handler
vectorB9:	.long	asm_exception_handler
vectorBA:	.long	asm_exception_handler
vectorBB:	.long	asm_exception_handler
vectorBC:	.long	asm_exception_handler
vectorBD:	.long	asm_exception_handler
vectorBE:	.long	asm_exception_handler
vectorBF:	.long	asm_exception_handler
vectorC0:	.long	asm_exception_handler
vectorC1:	.long	asm_exception_handler
vectorC2:	.long	asm_exception_handler
vectorC3:	.long	asm_exception_handler
vectorC4:	.long	asm_exception_handler
vectorC5:	.long	asm_exception_handler
vectorC6:	.long	asm_exception_handler
vectorC7:	.long	asm_exception_handler
vectorC8:	.long	asm_exception_handler
vectorC9:	.long	asm_exception_handler
vectorCA:	.long	asm_exception_handler
vectorCB:	.long	asm_exception_handler
vectorCC:	.long	asm_exception_handler
vectorCD:	.long	asm_exception_handler
vectorCE:	.long	asm_exception_handler
vectorCF:	.long	asm_exception_handler
vectorD0:	.long	asm_exception_handler
vectorD1:	.long	asm_exception_handler
vectorD2:	.long	asm_exception_handler
vectorD3:	.long	asm_exception_handler
vectorD4:	.long	asm_exception_handler
vectorD5:	.long	asm_exception_handler
vectorD6:	.long	asm_exception_handler
vectorD7:	.long	asm_exception_handler
vectorD8:	.long	asm_exception_handler
vectorD9:	.long	asm_exception_handler
vectorDA:	.long	asm_exception_handler
vectorDB:	.long	asm_exception_handler
vectorDC:	.long	asm_exception_handler
vectorDD:	.long	asm_exception_handler
vectorDE:	.long	asm_exception_handler
vectorDF:	.long	asm_exception_handler
vectorE0:	.long	asm_exception_handler
vectorE1:	.long	asm_exception_handler
vectorE2:	.long	asm_exception_handler
vectorE3:	.long	asm_exception_handler
vectorE4:	.long	asm_exception_handler
vectorE5:	.long	asm_exception_handler
vectorE6:	.long	asm_exception_handler
vectorE7:	.long	asm_exception_handler
vectorE8:	.long	asm_exception_handler
vectorE9:	.long	asm_exception_handler
vectorEA:	.long	asm_exception_handler
vectorEB:	.long	asm_exception_handler
vectorEC:	.long	asm_exception_handler
vectorED:	.long	asm_exception_handler
vectorEE:	.long	asm_exception_handler
vectorEF:	.long	asm_exception_handler
vectorF0:	.long	asm_exception_handler
vectorF1:	.long	asm_exception_handler
vectorF2:	.long	asm_exception_handler
vectorF3:	.long	asm_exception_handler
vectorF4:	.long	asm_exception_handler
vectorF5:	.long	asm_exception_handler
vectorF6:	.long	asm_exception_handler
vectorF7:	.long	asm_exception_handler
vectorF8:	.long	asm_exception_handler
vectorF9:	.long	asm_exception_handler
vectorFA:	.long	asm_exception_handler
vectorFB:	.long	asm_exception_handler
vectorFC:	.long	asm_exception_handler
vectorFD:	.long	asm_exception_handler
vectorFE:	.long	asm_exception_handler
vectorFF:	.long	asm_exception_handler
			.long	0 ; 0x400  - leave 408-40F free for debugger to put 
			.long	0 ; 0x404	vector catching routine
			.long	0 ; 0x408
			.long	0 ; 0x40C

start:
	move.w	#0x2700,SR
	jmp 	asm_startmeup
	
	.end
